<?php

namespace app\controllers\mikrotik\ip\ipsec;

use yii\helpers\Url;
use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\filters\VerbFilter;
use app\models\mikrotik\MikrotikSideMenu;
use yii\data\ArrayDataProvider;
use app\models\mikrotik\ip\ipsec\Proposals;

class ProposalsController extends Controller {

    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'except' => ['index'],
                'rules' => [
                    [
                        'actions' => ['create'],
                        'allow' => true,
                        'roles' => ['mikrotik_ipCreateIPsecProposals'],
                    ],
                    [
                        'actions' => ['delete'],
                        'allow' => true,
                        'roles' => ['mikrotik_ipDeleteIPsecProposals'],
                    ],
                    [
                        'actions' => ['disable'],
                        'allow' => true,
                        'roles' => ['mikrotik_ipDisableIPsecProposals'],
                    ],
                    [
                        'actions' => ['enable'],
                        'allow' => true,
                        'roles' => ['mikrotik_ipEnableIPsecProposals'],
                    ],
                    [
                        'actions' => ['update'],
                        'allow' => true,
                        'roles' => ['mikrotik_ipUpdateIPsecProposals'],
                    ],
                    [
                        'actions' => [],
                        'allow' => true,
                        'roles' => ['admin'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    public function actionIndex() {
        $model = new Proposals();
        return var_dump($model->getAll());
    }

    public function actionUpdate() {
        $id = Yii::$app->request->get('id');
        $menu = new MikrotikSideMenu();
        $model = new Proposals();

        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            if ($_POST['Proposals']['enc_algorithms'] != '') {
                $opt = implode(",", $_POST['Proposals']['enc_algorithms']);
                $model->enc_algorithms = $opt;
            }
            if ($_POST['Proposals']['auth_algorithms'] != '') {
                $opt = implode(",", $_POST['Proposals']['auth_algorithms']);
                $model->auth_algorithms = $opt;
            }
            $c = $model->update($id);
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/ip/ipsec/ipsec/index'));
            }
        } else {
            $model->get($id);
        }
        $model->enc_algorithms = explode(',', $model->enc_algorithms);
        $model->auth_algorithms = explode(',', $model->auth_algorithms);
        return $this->render('/mikrotik/ip/ipsec/proposals', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'update',
        ]);
    }

    public function actionCreate() {
        $menu = new MikrotikSideMenu();
        $model = new Proposals();

        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            if ($_POST['Proposals']['enc_algorithms'] != '') {
                $opt = implode(",", $_POST['Proposals']['enc_algorithms']);
                $model->enc_algorithms = $opt;
            }
            if ($_POST['Proposals']['auth_algorithms'] != '') {
                $opt = implode(",", $_POST['Proposals']['auth_algorithms']);
                $model->auth_algorithms = $opt;
            }
            $c = $model->create();
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/ip/ipsec/ipsec/index'));
            }
        }

        return $this->render('/mikrotik/ip/ipsec/proposals', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'create',
        ]);
    }

    public function actionDisable() {
        $id = Yii::$app->request->get('id');
        $model = new Proposals();
        $model->disable($id);
        return $this->redirect(Url::toRoute('mikrotik/ip/ipsec/ipsec/index'));
    }

    public function actionDelete() {
        $id = Yii::$app->request->get('id');
        $model = new Proposals();
        $model->delete($id);
        return $this->redirect(Url::toRoute('mikrotik/ip/ipsec/ipsec/index'));
    }

    public function actionEnable() {
        $id = Yii::$app->request->get('id');
        $model = new Proposals();
        $model->enable($id);
        return $this->redirect(Url::toRoute('mikrotik/ip/ipsec/ipsec/index'));
    }

}
